
/*
 * $Id: globals.h,v 1.84.2.2 1999/10/15 20:53:26 wessels Exp $
 *
 *
 * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
 * ----------------------------------------------------------
 *
 *  Squid is the result of efforts by numerous individuals from the
 *  Internet community.  Development is led by Duane Wessels of the
 *  National Laboratory for Applied Network Research and funded by the
 *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
 *  Duane Wessels and the University of California San Diego.  Please
 *  see the COPYRIGHT file for full details.  Squid incorporates
 *  software developed and/or copyrighted by other sources.  Please see
 *  the CREDITS file for full details.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 *
 */
#include "squid.h"

 FILE *debug_log=NULL;		/* NULL */
 FILE *cache_useragent_log=NULL;	/* NULL */
 SquidConfig Config;
 SquidConfig2 Config2;
 char *ConfigFile=NULL;	/* NULL */
 char *IcpOpcodeStr[];
 char *dns_error_message=NULL;	/* NULL */
 const char *log_tags[];
 char tmp_error_buf[ERROR_BUF_SZ];
 char *volatile debug_options=NULL;	/* NULL */
 char ThisCache[SQUIDHOSTNAMELEN << 1];
 char ThisCache2[SQUIDHOSTNAMELEN << 1];
 char config_input_line[BUFSIZ];
 const char *AclMatchedName=NULL;	/* NULL */
 const char *DefaultConfigFile=DEFAULT_CONFIG_FILE;
 const char *RequestMethodStr[];
 const char *ProtocolStr[];
 const char *cfg_filename=NULL;	/* NULL */
 const char *const appname="squid";	/* "squid" */
 const char *const dash_str="-";	/* "-" */
 const char *const localhost="127.0.0.1";	/* "127.0.0.1" */
 const char *const null_string="";	/* "" */
 const char *const version_string=SQUID_VERSION;
 const char *const full_appname_string="Squid/" SQUID_VERSION;
 const char *const w_space=" \t\n\r";
 const char *fdTypeStr[];
 const char *hier_strings[];
 const char *memStatusStr[];
 const char *pingStatusStr[];
 const char *storeStatusStr[];
 const char *swapStatusStr[];
 dnsStatData DnsStats;
 fde *fd_table=NULL;		/* NULL */
 int Biggest_FD=-1;		/* -1 */
 int Number_FD=0;		/* 0 */
 int Opening_FD=0;	/* 0 */
 int HttpSockets[MAXHTTPPORTS];
 int NDnsServersAlloc=0;	/* 0 */
 int NHttpSockets=0;	/* 0 */
 int RESERVED_FD;
 int Squid_MaxFD=SQUID_MAXFD;		/* SQUID_MAXFD */
 int config_lineno=0;	/* 0 */
 int debugLevels[MAX_DEBUG_SECTIONS];
 int do_mallinfo=0;		/* 0 */
 int opt_reuseaddr=1;	/* 1 */
 int icmp_sock=-1;		/* -1 */
 int neighbors_do_private_keys=1;	/* 1 */
 int opt_accel_uses_host=0;	/* 0 */
 int opt_catch_signals=1;	/* 1 */
 int opt_debug_stderr=-1;	/* -1 */
 int opt_dns_tests=1;	/* 1 */
 int opt_foreground_rebuild=0;	/* 0 */
 int opt_forwarded_for=1;	/* 1 */
 int opt_reload_hit_only=0;	/* 0 */
 int opt_syslog_enable=0;	/* 0 */
 int opt_udp_hit_obj=0;	/* 0 */
 int opt_create_swap_dirs=0;	/* 0 */
 int opt_store_doublecheck=0;	/* 0 */
 int syslog_enable=0;	/* 0 */
 int theInIcpConnection=-1;	/* -1 */
 int theOutIcpConnection=-1;	/* -1 */
 int DnsSocket=-1;		/* -1 */
#ifdef SQUID_SNMP
 int theInSnmpConnection=-1;	/* -1 */
 int theOutSnmpConnection=-1;	/* -1 */
 char *snmp_agentinfo;
#endif
 int vhost_mode=0;		/* 0 */
 int n_disk_objects=0;	/* 0 */
 iostats IOStats;
 struct _acl_deny_info_list *DenyInfoList=NULL;	/* NULL */
 struct in_addr any_addr;
 struct in_addr local_addr;
 struct in_addr no_addr;
 struct in_addr theOutICPAddr;
 struct in_addr theOutSNMPAddr;
 struct timeval current_time;
 struct timeval squid_start;
 time_t squid_curtime=0;	/* 0 */
 int shutting_down=0;	/* 0 */
 int reconfiguring=0;	/* 0 */
 int store_dirs_rebuilding=1;	/* 1 */
 int store_swap_size=0;	/* 0 */
 unsigned long store_mem_size=0;	/* 0 */
 time_t hit_only_mode_until=0;	/* 0 */
 StatCounters Counter;
 char *err_type_str[];
 char *icp_opcode_str[];
 char *swap_log_op_str[];
 char *lookup_t_str[];
 double request_failure_ratio=0.0;	/* 0.0 */
 double current_dtime;
 int store_hash_buckets=0;	/* 0 */
 hash_table *store_table=NULL;	/* NULL */
#if HEAP_REPLACEMENT
 heap *store_heap;
 heap *inmem_heap;
#else
 dlink_list store_list;
#endif
 dlink_list ClientActiveRequests;
 const String StringNull={ 0, 0, NULL };	/* { 0, 0, NULL } */
 const MemBuf MemBufNull=MemBufNULL;	/* MemBufNULL */
 int hot_obj_count=0;	/* 0 */
 int _db_level;
 const int CacheDigestHashFuncCount=4;	/* 4 */
 CacheDigest *store_digest=NULL;	/* NULL */
 const char *StoreDigestFileName="store_digest";		/* "store_digest" */
 const char *StoreDigestMimeStr="application/cache-digest";	/* "application/cache-digest" */
#if USE_CACHE_DIGESTS
 const Version CacheDigestVer={ 5, 3 };	/* { 5, 3 } */
#endif
 const char *MultipartMsgBoundaryStr="Unique-Squid-Separator";	/* "Unique-Squid-Separator" */
 icpUdpData *IcpQueueHead=NULL;	/* NULL */
#if HTTP_VIOLATIONS
 int refresh_nocache_hack=0;	/* 0 */
#endif
 request_flags null_request_flags;
 int store_open_disk_fd=0;	/* 0 */
 const char *SwapDirType[];

 int rename_unixstyle(const char *old_name, const char *new_name)
{
  int result;
  if (result=rename(old_name, new_name) != 0)
  {
    if (access(new_name, W_OK) == 0) remove(new_name);
    result = rename(old_name, new_name);
  }
  return result;
}